﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Clicker_2._0;

namespace UnitTestProject
{
    [TestClass]
    public class UnitTest1
    {
        MainWindow wnd = new MainWindow();
        long point = 0;
        static int click = 1;

        [TestMethod]
        public void ClickImgTest()
        {
            // 1 
            long resultPoints = 1;
            Assert.AreEqual(resultPoints, wnd.IncreasePoint(point, click));

            // 2
            point = 100;
            click = 3;
            resultPoints = 103;
            Assert.AreEqual(resultPoints, wnd.IncreasePoint(point, click));

            // 3
            point = 123;
            click = 17;
            resultPoints = 140;
            Assert.AreEqual(resultPoints, wnd.IncreasePoint(point, click));

            // 4
            point = 15;
            click = 15;
            resultPoints = 30;
            Assert.AreEqual(resultPoints, wnd.IncreasePoint(point, click));

        }

        [TestMethod]
        public void UpgradeBtn1Test()
        {
            // Btn1
            point = 0;
            Assert.IsFalse(wnd.IsUpgraded(point, 1));
            point = 312;
            Assert.IsTrue(wnd.IsUpgraded(point, 1));

            click = 1;
            int resultClick = 4;
            Assert.AreEqual(resultClick, wnd.IncreaseClick(click, 1));

            point = 312;
            long resultPoint = 0;
            Assert.AreEqual(resultPoint, wnd.DecreasePoint(point, 1));
        }

        [TestMethod]
        public void UpgradeBtn2Test()
        {
            // Btn2
            point = 499;
            Assert.IsFalse(wnd.IsUpgraded(point, 2));
            point = 1500;
            Assert.IsTrue(wnd.IsUpgraded(point, 2));

            click = 10;
            int resultClick = 20;
            Assert.AreEqual(resultClick, wnd.IncreaseClick(click, 2));

            point = 2000;
            long resultPoint = 772;
            Assert.AreEqual(resultPoint, wnd.DecreasePoint(point, 2));
        }

        [TestMethod]
        public void UpgradeBtn3Test()
        {
            // Btn3
            point = 1200;
            Assert.IsFalse(wnd.IsUpgraded(point, 3));
            point = 50000;
            Assert.IsTrue(wnd.IsUpgraded(point, 3));

            click = 20;
            int resultClick = 50;
            Assert.AreEqual(resultClick, wnd.IncreaseClick(click, 3));

            point = 50000;
            long resultPoint = 47252;
            Assert.AreEqual(resultPoint, wnd.DecreasePoint(point, 3));
        }

        [TestMethod]
        public void UpgradeBtn4Test()
        {
            // Btn4
            point = 0;
            Assert.IsFalse(wnd.IsUpgraded(point, 4));
            point = 50000;
            Assert.IsTrue(wnd.IsUpgraded(point, 4));

            click = 50;
            int resultClick = 100;
            Assert.AreEqual(resultClick, wnd.IncreaseClick(click, 4));

            point = 50000;
            long resultPoint = 1928;
            Assert.AreEqual(resultPoint, wnd.DecreasePoint(point, 4));
        }
    }
}
